package com.zsc.edu.gateway.framework.websocket;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.socket.config.annotation.EnableWebSocket;
import org.springframework.web.socket.config.annotation.WebSocketConfigurer;
import org.springframework.web.socket.config.annotation.WebSocketHandlerRegistry;

@Configuration
@EnableWebSocket
public class WebSocketConfig implements WebSocketConfigurer {

    @Override
    public void registerWebSocketHandlers(WebSocketHandlerRegistry registry) {
        registry.addHandler(deviceWebSocketHandler(), "/api/rest/ws/device/status")
                .setAllowedOrigins("*");
        registry.addHandler(recordWebSocketHandler(), "/api/rest/ws/record/status")
                .setAllowedOrigins("*");
        registry.addHandler(productWebSocketHandler(), "/api/rest/ws/product/status")
                .setAllowedOrigins("*");
    }

    @Bean
    public DeviceWebSocketHandler deviceWebSocketHandler() {
        return new DeviceWebSocketHandler();
    }

    @Bean
    public RecordWebSocketHandler recordWebSocketHandler() {
        return new RecordWebSocketHandler();
    }

    @Bean
    public ProductWebSocketHandler productWebSocketHandler() {
        return new ProductWebSocketHandler();
    }
}